/*************************************************************************************/
#include "UWater_eeprom_driver.h"
#include "UWater_timer1uS_driver.h" // Device header
#include "wdt.h"

/*------------------------------ Variable Define -------------------------------------*/
u8 s_g_EE_main_state = cst_EE_M_S0; //״̬״̬
static u8 s_g_EE_timeout_num = 0; //ʱ
static u8 s_g_I2C_State = cst_I2C_S0; //״̬״̬
u8* g_pData; //ȫݴָ
u8* g_pData_Temp; //ڱԭʼָ
u8 ee_len;//ݳ
u8 ee=0;
//u8 total_len;       //ܳ
u8* g_pMsg; //ȫMessageָ
u32 Timer1uSBase;
u32 odd_timer=0;
u32 readend_timer=0;
static u16 s_g_I2C_IO_Idx = 0; //ռ±
static u16 s_g_I2C_Len = 0; //ҪЩֽ
static u16 s_g_StartPageAddr = 0; //ʼҳԵַ
static u16 s_g_StartPageNum = 0; //ʼҳҪд
static u16 s_g_PageNum = 0; //Ҫдҳ
static u16 s_g_TurnPage = 0;
static u16 s_g_LastPage_Num = 0; //һҳݸ
static u16 s_g_MultPageflag = ERROR; //ҳд־
TWO_BYTE_TO_WORD target_addr; //Ŀַ(2ֽ)
EE_Message g_EE_Msg; //MessageϢṹ
M0P_I2C_TypeDef *hi2c1;

/*------------------------------ Function Define -------------------------------------*/
static void PointToIicSeqread(void); //I2CEEP
static void PointToIicSeqwrite(void); //I2CдEEP
static void GetIicResult(void); // I2C״ָ̬
static u8 I2cCheckCompleted(void); //ѰI2C״̬Ƿ
static u8 I2cCheckRorW(void); //ѰI2C״̬Ƕд
static u8 CheckTimer(u32 timer);
static void SetTimer(u32 timer);

/*************************************************************************************
 * @fun_name:	EepInit(void)
 * @brief   :
 * @param[in] :
 * @param[out] :None
 * @retval     :None
 * @other     :  I2Cʼ
 *************************************************************************************/
void EepInit(void)
{
    stc_gpio_cfg_t stcGpioCfg;
    stc_i2c_cfg_t stcI2cCfg;

    DDL_ZERO_STRUCT(stcGpioCfg);
    DDL_ZERO_STRUCT(stcI2cCfg);
     
    stcGpioCfg.enDir = GpioDirOut;
	stcGpioCfg.enDrv = GpioDrvH;      ///< ˿-> 
    stcGpioCfg.enPu = GpioPuDisable;
	stcGpioCfg.enPd = GpioPdDisable; 
	stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©->
	
    Gpio_Init(EE_POWER_GPIOx, EE_POWER_PIN, &stcGpioCfg);

    stcGpioCfg.enDir = GpioDirOut;                         ///< ˿ڷ
    stcGpioCfg.enOD = GpioOdEnable;                        ///< ˿ڿ©
    stcGpioCfg.enPu = GpioPuDisable;                        ///< ˿
    stcGpioCfg.enPd = GpioPdDisable;                       ///< ˿->ֹ
    Gpio_Init(EE_SCL_GPIOx, EE_SCL_PIN, &stcGpioCfg);
    Gpio_Init(EE_SDA_GPIOx, EE_SDA_PIN, &stcGpioCfg);

    Gpio_SetAfMode(EE_SCL_GPIOx, EE_SCL_PIN, EE_SCL_AFSEL);
    Gpio_SetAfMode(EE_SDA_GPIOx, EE_SDA_PIN, EE_SDA_AFSEL);

    POWER_EE_DOWN;

#if i2c0
    hi2c1 = M0P_I2C0;

    MCU_I2C_CLK_ENABLE();

    Reset_RstPeripheral0(ResetMskI2c0);

    stcI2cCfg.u32Pclk = Sysctrl_GetPClkFreq();  ///< ??PCLK??
    stcI2cCfg.u32Baud = I2C_CLK;                ///< 10KHz
    stcI2cCfg.enMode = I2cMasterMode;           ///< ????
    stcI2cCfg.u8SlaveAddr = 0x55;               ///< ???,?????
    stcI2cCfg.bGc = FALSE;                      ///< ??????????
    I2C_Init(hi2c1,&stcI2cCfg);                 ///< ?????

    /* Peripheral interrupt init*/
    //жȼ
    EnableNvic(I2C0_IRQn, IrqLevel2, TRUE);     ///< ??????
#endif

#if i2c1
    hi2c1 = M0P_I2C1;

    MCU_I2C_CLK_ENABLE();

    Reset_RstPeripheral0(ResetMskI2c1);
       
    stcI2cCfg.u32Pclk = Sysctrl_GetPClkFreq();  ///< ȡPCLKʱ
    stcI2cCfg.u32Baud = I2C_CLK;                ///< 10KHz
    stcI2cCfg.enMode = I2cMasterMode;           ///< ģʽ
    stcI2cCfg.u8SlaveAddr = 0x55;               ///< ӵַģʽЧ
    stcI2cCfg.bGc = FALSE;                      ///< 㲥ַӦʹܹر
    I2C_Init(hi2c1,&stcI2cCfg);                 ///< ģʼ

    /* Peripheral interrupt init*/
    //жȼ
    EnableNvic(I2C0_IRQn, IrqLevel2, TRUE);     ///< 
#endif

}
/*************************************************************************************
 * @fun_name:	EepMachineDriver(void)
 * @brief   :
 * @param[in] :	 None
 * @param[out] :None
 * @retval     :    None
 * @other     :  ǰ̨״̬
 *************************************************************************************/
void EepMachineDriver(void)
{
    switch (s_g_EE_main_state) //IDLE״̬
    {
        case cst_EE_M_S0:
        break;
		
        case cst_EE_M_S1: //
        {
            s_g_EE_main_state = cst_EE_M_S3;
            PointToIicSeqread();
            SetTimer(600000); //趨600msʱʱ
        }
        break;
        case cst_EE_M_S2: //д
        {
            s_g_EE_main_state = cst_EE_M_S3;
            PointToIicSeqwrite();
            SetTimer(600000); //趨600msʱʱ
        }
        break;
        case cst_EE_M_S3: //ѯʱʱǷ
        {
            if(CheckTimer(600000)) //ʱʱ䵽
            {
			I2C_ClearIrq(hi2c1);//رһж
            if (s_g_EE_timeout_num == 0)
            {
                if (SUCCESS == I2cCheckRorW()) //ʱδɣִд
                {
                    ++s_g_EE_timeout_num;
                    GetIicResult();
                    I2CIE_CLOSE;
                    POWER_EE_DOWN;
                    MCU_I2C_CLK_DISABLE();
                    SetTimer(600000);
                    s_g_EE_main_state = cst_EE_M_S7;
                }
                else //ʱδɣִж
                {
                    ++s_g_EE_timeout_num;
                    GetIicResult();
                    I2CIE_CLOSE;
                    POWER_EE_DOWN;
                    MCU_I2C_CLK_DISABLE();
                    SetTimer(600000);
                    s_g_EE_main_state = cst_EE_M_S8;
                }
            }
            else //ξʱ
            {
                s_g_EE_timeout_num = 0;
                GetIicResult();
                POWER_EE_DOWN;
                SetTimer(600000);
                s_g_EE_main_state = cst_EE_M_S4;
            }
        }
        else
        {
            if (SUCCESS == I2cCheckCompleted())
            {
                if (SUCCESS == I2cCheckRorW()) //д񣬵50mS
                {
                    GetIicResult();
                    s_g_EE_timeout_num = 0;
                    SetTimer(50000);
                    s_g_EE_main_state = cst_EE_M_S6;
                }
                else
                {
                    if((Timer1usGetTick() - readend_timer) > 200) //жʱ200usEEϵ
                    {
                        GetIicResult(); //񣬷IDLE
                        s_g_EE_timeout_num = 0;
                        I2CIE_CLOSE;
                        POWER_EE_DOWN;
                        MCU_I2C_CLK_DISABLE();
                        s_g_EE_main_state = cst_EE_M_S0;
                    }
                }
            }
            else
            {
                if(s_g_TurnPage == TRUE)
                {
                    if((Timer1usGetTick() - odd_timer) > 5000)
                    {
                        s_g_TurnPage = FALSE;
                        I2C_SetFunc(hi2c1,I2cStart_En);
                    }
                }
                s_g_EE_main_state = cst_EE_M_S3;
            }
        }
    }
    break;
    case cst_EE_M_S4: //Start
    {
        if(CheckTimer(600000))
        {
            EepInit();
            POWER_EE_UP;           
            I2CIE_OPEN;
            I2C_SetFunc(hi2c1, I2cStart_En); //ʼ
            SetTimer(600000);
            s_g_EE_main_state = cst_EE_M_S5;
        }
        else
            s_g_EE_main_state = cst_EE_M_S4;
    }
    break;
    case cst_EE_M_S5: //ָStop
    {
        if(CheckTimer(600000))
        {
            if( I2c_GET_FLAG(hi2c1, I2C_ISR_START))
            {
                I2C_SetFunc(hi2c1, I2cStop_En);
                I2CIE_CLOSE;
                POWER_EE_DOWN;
                MCU_I2C_CLK_DISABLE();
                s_g_EE_main_state = cst_EE_M_S0;
            }
            else //λ0
            {
                g_EE_Msg.structs.EE_normal = ERROR;
                I2CIE_CLOSE;
                POWER_EE_DOWN;
                MCU_I2C_CLK_DISABLE();
                s_g_EE_main_state = cst_EE_M_S0;
            }
        }
        else
        {
            s_g_EE_main_state = cst_EE_M_S5;
        }
       break;
    }

    case cst_EE_M_S6:
    {
        if (CheckTimer(50000))
        {
            I2CIE_CLOSE;
            POWER_EE_DOWN;
            MCU_I2C_CLK_DISABLE();
            s_g_EE_main_state = cst_EE_M_S0;
        }
        else
        {
            s_g_EE_main_state = cst_EE_M_S6;
        }
        break;   
    }
        case cst_EE_M_S7://ʱʱϵ磬д
    {
        Wdt_Feed();//ιΪ˵EEPʱ±Ƹλ 
        if (CheckTimer(600000))
        {	
            EepInit();
            POWER_EE_UP; 
            I2CIE_OPEN; 
            MCU_I2C_CLK_ENABLE();
            s_g_EE_main_state = cst_EE_M_S2;
        }
        break;
    }		
    case cst_EE_M_S8://ʱʱϵ磬
    {
        Wdt_Feed();//ιΪ˵EEPʱ±Ƹλ
        if (CheckTimer(600000))
        {           
            EepInit();
            POWER_EE_UP;
            I2CIE_OPEN;
            MCU_I2C_CLK_ENABLE();
            s_g_EE_main_state = cst_EE_M_S1;
        }
        break;
    }
	default:
	{
		s_g_EE_main_state = cst_EE_M_S0;
		break;
	}

  }
}

/*************************************************************************************
 * @fun_name:	void  SetTimer(u32 timer)
 * @brief   :
 * @param[in] :	 None
 * @param[out] :None
 * @retval     :    None
 * @other     :    ڲӿ
 *************************************************************************************/
void  SetTimer(u32 timer)
{
    Timer1uSBase=Timer1usGetTick();
}
/*************************************************************************************
* @fun_name:	void  SetTimer(u32 timer)
* @brief   :
* @param[in] :	 None
* @param[out] :None
* @retval     :    None
* @other     :    ڲӿ
*************************************************************************************/
u8 CheckTimer(u32 timer)
{
    u32 NowTimer=0;
    u32 a=0;
    a=Timer1usGetTick();
    NowTimer=a-Timer1uSBase;
    if(timer==50000 && (NowTimer>=timer))
    {
        return 1;
    }
    if(timer == 600000 && (NowTimer >= timer))
    {
        return 1;
    }
    else
        return 0;

}
/*************************************************************************************
 * @fun_name:	void I2cIsrMachine(void)
 * @brief   :
 * @param[in] :	 None
 * @param[out] :None
 * @retval     :    None
 * @other     :    ڲӿ
 *************************************************************************************/
void I2c0_IRQHandler(void)
{

    switch (s_g_I2C_State)
    {
    case cst_I2C_S0:
    {
        I2C_ClearFunc(hi2c1, I2cStart_En);
        I2C_SetFunc(hi2c1,I2cStop_En);
    }
    break;
    case cst_I2C_SR_S1://Ŀַֽ
    {
        if( I2c_GET_FLAG(hi2c1, I2C_ISR_START))
        {
            I2C_ClearFunc(hi2c1,I2cStart_En);
            I2C_ClearFunc(hi2c1, I2cStop_En);
            I2C_WriteByte(hi2c1, Write_Addr);
        }
        else if( I2c_GET_FLAG(hi2c1, I2C_ISR_TXADDR))//
        {
            s_g_I2C_State = cst_I2C_SR_S2;
            I2C_ClearFunc(hi2c1, I2cStart_En);
            I2C_ClearFunc(hi2c1, I2cStop_En);
            I2C_WriteByte(hi2c1, I2c_MEM_ADD_MSB(target_addr.word_form));
        }

    }
    break;
    case cst_I2C_SR_S2://Ŀַֽ
    {
        if(I2c_GET_FLAG(hi2c1, I2C_ISR_TXDATA))
        {
            s_g_I2C_State = cst_I2C_SR_S3;
//					I2C_ClearFunc(hi2c1, I2cStart_En);
//					I2C_ClearFunc(hi2c1, I2cStop_En);
            I2C_WriteByte(hi2c1, I2c_MEM_ADD_LSB(target_addr.word_form));
        }
    }
    break;
    case cst_I2C_SR_S3:
    {
        if(I2c_GET_FLAG(hi2c1, I2C_ISR_TXDATA))
        {
            I2C_SetFunc(hi2c1,I2cStart_En);
            I2C_ClearFunc(hi2c1,I2cStop_En);
        }
        else if(I2c_GET_FLAG(hi2c1, I2C_ISR_REPSTART))
        {
            I2C_ClearFunc(hi2c1, I2cStart_En);
            I2C_ClearFunc(hi2c1, I2cStop_En);
            I2C_WriteByte(hi2c1, Read_Addr);
            if(s_g_I2C_Len == 1) //ֻ1ֽڵ
            {
                I2C_ClearFunc(hi2c1, I2cAck_En); //NACK
            }
            else
            {
                I2C_SetFunc(hi2c1, I2cAck_En); //ACK
            }
        }
        else if(I2c_GET_FLAG(hi2c1, I2C_ISR_READADDR))
        {
            s_g_I2C_State = cst_I2C_SR_S4;
        }
    }
    break;
    case cst_I2C_SR_S4:
    {
        if(I2c_GET_FLAG(hi2c1, I2C_ISR_READDATA))
        {
            /* Read data from RXDR */
            if(s_g_I2C_Len)
            {
                (*g_pData++) = I2C_ReadByte(hi2c1);
                I2C_ClearFunc(hi2c1, I2cStart_En);
                I2C_ClearFunc(hi2c1, I2cStop_En);
                s_g_I2C_Len--;
                if(s_g_I2C_Len == 1) //Ҫ1ֽڵ
                {
                    s_g_I2C_State = cst_I2C_SR_S5;
                    I2C_ClearFunc(hi2c1, I2cAck_En);
                }
                else
                {
                    I2C_SetFunc(hi2c1,I2cAck_En); //ACK
                }
            }
        }
        else if(I2c_GET_FLAG(hi2c1, I2C_ISR_READDATA_NOACK)) //ѽֽڣACKѷ
        {
            (*g_pData++) = I2C_ReadByte(hi2c1);
            s_g_I2C_Len--;
            if(0 == s_g_I2C_Len)
            {
                I2C_ClearFunc(hi2c1, I2cStart_En);
                I2C_SetFunc(hi2c1, I2cStop_En);
                readend_timer = Timer1usGetTick(); //ʱֹ֤ͣͳɹ
                g_EE_Msg.structs.Completed = SUCCESS;
                s_g_I2C_State = cst_I2C_S0;
            }
        }
    }
    break;
    case cst_I2C_SR_S5:
    {
        if(I2c_GET_FLAG(hi2c1, I2C_ISR_READDATA_NOACK)) //ѽֽڣACKѷ
        {
            (*g_pData++) = I2C_ReadByte(hi2c1);
            s_g_I2C_Len--;
            if(s_g_I2C_Len == 0)
            {
                I2C_ClearFunc(hi2c1, I2cStart_En);
                I2C_SetFunc(hi2c1,I2cStop_En);
                readend_timer = Timer1usGetTick(); //ʱֹ֤ͣͳɹ
                g_EE_Msg.structs.Completed = SUCCESS;
                s_g_I2C_State = cst_I2C_S0;
            }
        }
    }
    break;

    case cst_I2C_SW_S1: //Ŀַֽ
    {
        s_g_I2C_IO_Idx = 0;
        if(I2c_GET_FLAG(hi2c1, I2C_ISR_START))
        {
            I2C_ClearFunc(hi2c1,I2cStart_En);
            I2C_ClearFunc(hi2c1, I2cStop_En);
            I2C_WriteByte(hi2c1, Write_Addr);

        }
        else if(I2c_GET_FLAG(hi2c1, I2C_ISR_TXADDR))
        {
            s_g_I2C_State = cst_I2C_SW_S2;
            I2C_ClearFunc(hi2c1, I2cStart_En);
            I2C_ClearFunc(hi2c1, I2cStop_En);
            I2C_WriteByte(hi2c1, I2c_MEM_ADD_MSB(target_addr.word_form));
        }
//			if((I2c_GET_FLAG(hi2c1, I2C_ISR_NACKF) == TRUE) || (I2c_GET_FLAG(hi2c1, I2C_ISR_STOPF) == TRUE)	)
//			{
//				I2c_CLEAR_FLAG(hi2c1, I2C_ISR_NACKF);
//				I2c_CLEAR_FLAG(hi2c1, I2C_ISR_STOPF);
//			}
    }
    break;
    case cst_I2C_SW_S2://Ŀַֽ
    {
        if(I2c_GET_FLAG(hi2c1, I2C_ISR_TXDATA))
        {
            s_g_I2C_State = cst_I2C_SW_S3;
            I2C_WriteByte(hi2c1, I2c_MEM_ADD_LSB(target_addr.word_form));
        }
//			if(I2c_GET_FLAG(hi2c1, I2C_ISR_NACKF) == TRUE	)
//			{
//				s_g_I2C_State = cst_I2C_SW_S1;
//				I2c_CLEAR_FLAG(hi2c1, I2C_ISR_NACKF);
//				I2c_CLEAR_FLAG(hi2c1, I2C_ISR_STOPF);
//			}
    }
    break;
    case cst_I2C_SW_S3:
    {
        if(I2c_GET_FLAG(hi2c1, I2C_ISR_TXDATA))
        {
            if(s_g_I2C_IO_Idx == (s_g_I2C_Len - 1)) //ڴ浱ǰҳдһֽ
            {
                odd_timer = Timer1usGetTick();
                I2C_WriteByte(hi2c1, *(g_pData+ s_g_I2C_IO_Idx));
                if((s_g_MultPageflag == SUCCESS) && (s_g_StartPageAddr == 0) && (s_g_PageNum > 0)) //ҳ&ʼҳԵַΪ&ֹһҳ
                {
                    s_g_PageNum -= 1;
                }
                s_g_I2C_State = cst_I2C_SW_S4;
            }
            else if(s_g_I2C_IO_Idx < (s_g_I2C_Len - 1)) //ڴ浱ǰҳдķһֽ
            {
                s_g_I2C_State = cst_I2C_SW_S3;
                I2C_WriteByte(hi2c1, *(g_pData+ s_g_I2C_IO_Idx));
                ++s_g_I2C_IO_Idx;
            }
        }
//			else if((I2c_GET_FLAG(hi2c1, I2C_ISR_WRITEADDR_NOACK))||(I2c_GET_FLAG(hi2c1, I2C_ISR_WRITEFAIL)))
//			{
//				I2C_SetFunc(hi2c1,I2cStart_En);
//			}
//			else if(I2c_GET_FLAG(hi2c1, I2C_ISR_WRITEDATA_NOACK))
//			{
//				s_g_I2C_State = cst_I2C_S0;
//				I2C_SetFunc(hi2c1,I2cStop_En);
//			}

    }
    break;

    case cst_I2C_SW_S4:
    {
        if(I2c_GET_FLAG(hi2c1, I2C_ISR_TXDATA))
        {
            if (s_g_MultPageflag == ERROR) //С1ҳѾдꡣIDEL
            {
                s_g_I2C_State = cst_I2C_S0;
                g_EE_Msg.structs.Completed = SUCCESS;
                I2C_ClearFunc(hi2c1, I2cStart_En);
                I2C_SetFunc(hi2c1,I2cStop_En);
            }
            else
            {
                if (s_g_StartPageAddr != 0) //ҳʼλд
                {
                    target_addr.word_form += s_g_StartPageNum;
                    g_pData += s_g_StartPageNum;
                    if (s_g_PageNum > 0)
                    {
                        s_g_I2C_Len = EEPageSize;
                    }
                    else
                    {
                        s_g_I2C_Len = s_g_LastPage_Num;
                        s_g_LastPage_Num = 0;
                    }
                    s_g_StartPageAddr = 0;
                    s_g_I2C_State = cst_I2C_SW_S5;
                    s_g_TurnPage = TRUE;
                    I2C_ClearFunc(hi2c1,I2cStart_En);
                    I2C_SetFunc(hi2c1, I2cStop_En);
                }
                else
                {
                    if (s_g_PageNum > 0)
                    {
                        target_addr.word_form += EEPageSize;
                        g_pData += EEPageSize;
                        s_g_I2C_Len = EEPageSize;
                        s_g_I2C_State = cst_I2C_SW_S5;
                        s_g_TurnPage = TRUE;
                        I2C_ClearFunc(hi2c1,I2cStart_En);
                        I2C_SetFunc(hi2c1, I2cStop_En);
                    }
                    else //ʣһҳ
                    {
                        if (s_g_LastPage_Num > 0)
                        {
                            target_addr.word_form += EEPageSize;
                            g_pData += EEPageSize;
                            s_g_I2C_Len = s_g_LastPage_Num;
                            s_g_LastPage_Num = 0;
                            s_g_I2C_State = cst_I2C_SW_S5;
                            s_g_TurnPage = TRUE;
                            I2C_ClearFunc(hi2c1,I2cStart_En);
                            I2C_SetFunc(hi2c1, I2cStop_En);
                        }
                        else if (s_g_LastPage_Num == 0) //
                        {
                            g_EE_Msg.structs.Completed = SUCCESS;
                            s_g_I2C_State = cst_I2C_S0;
                            I2C_ClearFunc(hi2c1,I2cStart_En);
                            I2C_SetFunc(hi2c1,I2cStop_En);
                        }
                    }
                }
            }
        }
//			else if(I2c_GET_FLAG(hi2c1, I2C_ISR_WRITEDATA_NOACK))
//			{
//				s_g_I2C_State = cst_I2C_S0;
//				I2C_SetFunc(hi2c1,I2cStop_En);
//			}
    }
    break;
    case cst_I2C_SW_S5:
    {
        if(I2c_GET_FLAG(hi2c1, I2C_ISR_REPSTART))
        {
            s_g_I2C_State = cst_I2C_SW_S1;
            I2C_ClearFunc(hi2c1,I2cStart_En);
            I2C_ClearFunc(hi2c1, I2cStop_En);
            I2C_WriteByte(hi2c1, Write_Addr);
        }
    }
    break;

    default:
    {
        s_g_I2C_State = cst_I2C_S0;
        I2C_ClearFunc(hi2c1, I2cStart_En);
        I2C_SetFunc(hi2c1,I2cStop_En);
    }
    break;
    }
    I2C_ClearIrq(hi2c1);
}

/*************************************************************************************
 * @fun_name:	void I2C1_EV_IRQHandler(void)
 * @brief   :
 * @param[in] :	 None
 * @param[out] :None
 * @retval     :    None
 * @other     :  I2C1ж
 *************************************************************************************/
//void I2c0_IRQHandler(void)
//{
//	I2cIsrMachine();
//}

/*************************************************************************************
 * @fun_name:	u8 EepIfIdle (void)
 * @brief   :
 * @param[in] :	 None
 * @param[out] :TASK_IDLE:;TASK_BUSY:æµ
 * @retval     :    None
 * @other     :   ӿ
 *************************************************************************************/
u8 EepIfIdle(void)
{
    if (s_g_EE_main_state == cst_EE_M_S0)// && I2c_GET_FLAG(hi2c1, I2C_ISR_IDLE) == TRUE)
        return TASK_IDLE;
    else
        return TASK_BUSY;
}

/*************************************************************************************
 * @fun_name:	u8 EepRead(u16 EEaddr,u8 * Data,u8 Num,u8* pMsg)
 * @brief   :      EEPROM
 * @param[in] :	 洢ֽڵַ(2ֽ)EEaddr,ַҪ洢λָdata,ֽnum,ȡз״̬ϢָpMsg
 * @param[out] :SUCCESS:ЧжϳɹȡERRORЧжʧܣȡ
                          ȡ (*data)ݳmessage (*pMsg)
 * @retval     :    None
 * @other     :    ӿ
 *************************************************************************************/
u8 EepRead(u16 EEaddr, u8* Data, u16 Num, u8* pMsg)
{
    g_EE_Msg.MessageInfo=0x40;
    *pMsg = 0;
    if (EEaddr + Num <= (EE_ADDR_MAX+1))
    {
        if (Num > 0 && Num <= READ_LIMITSIZE_MAX) //???????
        {
            target_addr.word_form = EEaddr;
            g_pData_Temp = Data;
            s_g_I2C_Len = Num;
            g_pMsg = pMsg;
			MCU_I2C_CLK_ENABLE();
			POWER_EE_UP;  //EEP
			I2CIE_OPEN;
            s_g_EE_main_state = cst_EE_M_S1;
            return SUCCESS;
        }
        else
            return ERROR;
    }
    else
        return ERROR;
}
/*************************************************************************************
 * @fun_name:	void PointToIicSeqread(void)
 * @brief   :        I2CEEPROMж״̬
 * @param[in] :	 None
 * @param[out] :None
 * @retval     :    None
 * @other     :    ڲӿ
 *************************************************************************************/
void PointToIicSeqread(void)
{
    s_g_I2C_State = cst_I2C_SR_S1;
    g_pData = g_pData_Temp;

    I2C_ClearFunc(hi2c1, I2cStop_En);
    I2C_SetFunc(hi2c1, I2cStart_En);
}
/*************************************************************************************
 * @fun_name:	u8 EepWrite (u8* Data,u16 EEaddr,u16 Num,u8* pMsg)
 * @brief   :       дEEPROM
 * @param[in] :	洢дݵλָdata洢ֽڵַ2ֽڣEEaddrдֽnum,дз״̬ϢָpMsg
 * @param[out] :_SUCCESS:Чжϳɹд룻_ERRORЧжʧܣд
                          ݳmessage (*pMsg)
 * @retval     :    None
 * @other     :   ӿ
 *************************************************************************************/
u8 EepWrite(u8* Data, u16 EEaddr, u16 Num, u8* pMsg)
{
    g_EE_Msg.MessageInfo=0x60;
    *pMsg = 0;
    if (EEaddr + Num <= (EE_ADDR_MAX+1))
    {
        if (Num > 0 && Num <=WRITE_LIMITSIZE_MAX)
        {
            target_addr.word_form = EEaddr;
            g_pData_Temp = Data;
            s_g_StartPageAddr = EEaddr % EEPageSize;
            s_g_StartPageNum = EEPageSize - s_g_StartPageAddr;
            s_g_PageNum = Num / EEPageSize;
            s_g_LastPage_Num = Num % EEPageSize;
            if (0 == s_g_PageNum)
            {
                if ((s_g_StartPageAddr + Num) > EEPageSize)
                {
                    s_g_MultPageflag = SUCCESS;
                    Num -= s_g_StartPageNum;
                    s_g_PageNum = Num / EEPageSize;
                    s_g_LastPage_Num = Num % EEPageSize;
                    s_g_I2C_Len = s_g_StartPageNum;
                }
                else
                {
                    s_g_MultPageflag = ERROR; //Сһҳ
                    s_g_I2C_Len = s_g_LastPage_Num;
                }
            }
            else
            {
                s_g_MultPageflag = SUCCESS; //ݴڵһҳ
                if (s_g_StartPageAddr == 0)
                {
                    s_g_I2C_Len = EEPageSize;
                }
                else
                {
                    Num -= s_g_StartPageNum;
                    s_g_PageNum = Num / EEPageSize;
                    s_g_LastPage_Num = Num % EEPageSize;
                    s_g_I2C_Len = s_g_StartPageNum;
                }
            }
            g_pMsg = pMsg;
			MCU_I2C_CLK_ENABLE();
			POWER_EE_UP; //EEP
			I2CIE_OPEN;
            s_g_EE_main_state = cst_EE_M_S2;
            return SUCCESS;
        }
        else
            return ERROR;
    }
    else
        return ERROR;
}
/*************************************************************************************
 * @fun_name:	void PointToIicSeqwrite(void)
 * @brief   :        I2CдEEPROMж״̬
 * @param[in] :	 None
 * @param[out] :None
 * @retval     :    None
 * @other     :    ڲӿ
 *************************************************************************************/
void PointToIicSeqwrite(void)
{
    s_g_I2C_State = cst_I2C_SW_S1;
    g_pData = g_pData_Temp;

    I2C_ClearFunc(hi2c1, I2cStop_En);
    I2C_SetFunc(hi2c1, I2cStart_En);
    
}
/*************************************************************************************
 * @fun_name:	u8 EepCheckMsg (u8 Msg)
 * @brief   :       ԼMsgѯǷ
 * @param[in] :	Լ״̬ϢMsg
 * @param[out] :SUCCESS:ɣERRORδ
 * @retval     :    None
 * @other     :     MainSpaceڶӿڣӿ
 *************************************************************************************/
u8 EepCheckMsg(u8 Msg)
{
    if ((SUCCESS == I2cCheckCompleted())&&EepIfIdle())
        return SUCCESS;
    else
        return ERROR;
}

/*************************************************************************************
 * @fun_name:	u8 EepCheckState(u8 Msg)
* @brief   :        ԼMsgѯEEPROMǷ쳣
 * @param[in] :	 Լ״̬ϢMsg
 * @param[out] :SUCCESS:EEPROMERROR_IESEEPROM쳣
 * @retval     :    None
 * @other     :    MainSpaceڶӿڣӿ
 *************************************************************************************/
u8 EepCheckState(void)
{
    return g_EE_Msg.structs.EE_normal;
}

/*************************************************************************************
 * @fun_name:	void EepPreSleep(void)
 * @brief   :        EEPģ
 * @param[in] :	 None
 * @param[out] :None
 * @retval     :    None
 * @other     :   MainSpaceӿڣ߽ӿ
 *************************************************************************************/
void EepPreSleep(void)
{

}

/*************************************************************************************
 * @fun_name:	u8 EepIfSleep(void)
 * @brief   :        ѯEEPROMģǷ
 * @param[in] :	 None
 * @param[out] :TRUE:EEPROMģߣFALSEEEPROMģ鲻
 * @retval     :    None
 * @other     :   MainSpaceӿڣ߽ӿ
 *************************************************************************************/
u8 EepIfSleep(void)
{
    if(cst_EE_M_S0 == s_g_EE_main_state)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

/*************************************************************************************
 * @fun_name:	void EepWakeSleep(void)
 * @brief   :        EEPROMģ
 * @param[in] :	 None
 * @param[out] :None
 * @retval     :    None
 * @other     :    MainSpaceӿڣѽӿ
 *************************************************************************************/
void EepWakeSleep(void)
{

}

/********************************************************
 * @fun_name:	void GetIicResult(void)
 * @brief   :   I2Cж״ָ̬
 * @param[in] :
 * @param[out] :
 * @retval     :    None
 * @other     :    ڲӿ
 *******************************************************/
void GetIicResult(void)
{
    *g_pMsg = g_EE_Msg.MessageInfo;
}

/*************************************************************************************
 * @fun_name:	u8 I2cCheckCompleted(void)
 * @brief   :        ѯж״̬Ƿ
 * @param[in] :	 None
 * @param[out] :SUCCESS:ɣERRORδ
 * @retval     :    None
 * @other     :    ڲӿ
 *************************************************************************************/
u8 I2cCheckCompleted(void)
{
    return g_EE_Msg.structs.Completed;
}

/*************************************************************************************
 * @fun_name:	u8 I2cCheckRorW(void)
 * @brief   :        ѯж״̬Ƕд
 * @param[in] :	 None
 * @param[out] :ERROR:SUCCESSд
 * @retval     :    None
 * @other     :    ڲӿ
 *************************************************************************************/
u8 I2cCheckRorW(void)
{
    return g_EE_Msg.structs.EorW;
}

