/************************************************************************************
* @Copyright (c)	  :(C)2020, Qindao ieslab Co., Ltd
* @FileName   		  :hc32_gpio_driver.c
* @Author           :QDIES PLATFORM TEAM
* @Version          :V1.0
* @Date             :2020-07-01
* @Description      :
************************************************************************************/

#ifdef	__cplusplus
extern "C"
{
#endif

#include "UWater_lvd_driver.h"

void LVDInit(void)
{
		stc_lvd_cfg_t stcLvdCfg;

    DDL_ZERO_STRUCT(stcLvdCfg);                                 //0
	  
    Gpio_SetAnalogMode(LVD_POW_PORT, LVD_POW_PIN);              ///< LVD INPUT SOURCE
	
    Sysctrl_SetPeripheralGate(SysctrlPeripheralVcLvd, TRUE);    //LVDʱ
	  
    stcLvdCfg.enAct        = LvdActMskInt;              ///< ôж
    stcLvdCfg.enInputSrc   = LVD_SRC;                   ///< LVDԴ
    stcLvdCfg.enThreshold  = LvdMskTH2_8V;              ///< LVD׼ѹ
    stcLvdCfg.enFilter     = LvdFilterMskEnable;        ///< ˲ʹ
    stcLvdCfg.enFilterTime = LvdFilterMsk28_8ms;        ///< ˲ʱ
    stcLvdCfg.enIrqType    = LvdIrqMskRiseFall;         ///< жϴ
    Lvd_Init(&stcLvdCfg);
    
    Lvd_EnableIrq();                                    ///< жϿ
    Lvd_ClearIrq();
    EnableNvic(LVD_IRQn, IrqLevel3, TRUE);              ///< NVIC жʹ
    
    Lvd_Enable();                                       ///< LVD ģʹ
	
}

///< LVD жϷ
void Lvd_IRQHandler(void)
{
    Lvd_ClearIrq();
		
}

#ifdef	__cplusplus
}
#endif
