/*******************************************************************************
* @Copyright (c)    :(C)2017, Qingdao ieslab Co., Ltd
* @FileName         :GP22Gas_valve_driver.c
* @Author           :Kv-L
* @Version          :V1.0
* @Date             :201759 13:29:52
* @Description      :the function of the entity of GP22Gas_valve_driver.c
*******************************************************************************/



#ifdef _cplusplus
extern "C"
{
#endif


/* Includes ------------------------------------------------------------------*/
#include "UWater_valve_driver.h"
#include "UWater_timer1uS_driver.h"	
#include "UWater_adc_driver.h"
#include "UWater_eeprom_driver.h"
#include "UWater_rtcc_driver.h"
#include "eeprom_app.h"
#include "UWater_frame_app.h"
#include "UWater_valve_app.h"
#if defined(VALVE)
/*---------------------------------????--------------------------------------------*/
/*????*/
static u8 s_g_valve_s = VALVE_IDLE;       	/*¼״̬״̬*/
static u8 s_g_adc_valve_s = 0; 			 	/*¼״̬״̬*/
//static u8 s_g_valve_state = 0;           	/*¼ŵ״̬*/
static u8 s_g_valve_open_close = 0;      	/*¼յĿطָ*/
//static u8 s_g_valve_msg = 0;            	/*صԪ׳msg*/
u8 g_valve_message_temp = 0;            	/*дEEϢ*/
//static u8 s_g_valve_wait_ee_flag = 0;    	/*ȴдEEʱָֹظִеı־*/
static u8 s_g_error_count = 0;          	/*¼Ŷת*/
//static u8 s_g_valve_flag = 0;           	/*뿪ʱ¼ǰǿǹرգ1Ϊ2Ϊر*/
//static u16 valve_half_time = 0;        		/*뿪ʱ*/
static u8 valve_if_op = 0;
static u8 valve_if_cl = 0;
//static u8 valve_power_order = 0xAA;     	//˳,Ĭȷ
//static u8 valve_inplace_order = 0xAA;   	//λ˳Ĭȷ
static u16 valve_time_ms = 20*200;          //طʱ
u16 valve_adc_voltage_thd = 30*4*10; 

static u8 valve_adc_check_msg = 0;
static u8 valve_adc_count = 0;
u32 g_valve_adc_energy;
u8 valve_adc_complete;
u8 g_valve_store_rcv_state_flag = 0;
u8 g_valve_store_err_state_flag = 0;
//u8 g_valve_store_rcv_state = 0;
static u8 g_valve_init_flag = 0;
static u8 s_g_valve_init_s = 0;
static u8 s_g_valve_store_s = 0;

void ValvePowerOnOrder(u8 IsOpen,u8 IsClose);
void ValveGetInplaceOrder(void);
void ValveSetState(void);
void ValveStoreEeDriver(void);
void ValveInitOperate(void);
/*************************************************************************************
 * @fun_name    :ValveInit
 * @brief       :valve???
 * @param[in] 	:none
 * @param[out] 	:None
 * @retval     	:None
 * @other       :
 *************************************************************************************/
void ValveInit(void)
{ 
	/*nSleep*/
	stc_gpio_cfg_t stcGpioCfg;

	DDL_ZERO_STRUCT(stcGpioCfg);
	stcGpioCfg.enDir = GpioDirOut;
	///< ˿->
	stcGpioCfg.enDrv =GpioDrvL;
	///< ˿->
	stcGpioCfg.enPu = GpioPuDisable;
	stcGpioCfg.enPd = GpioPdDisable;
	///< ˿ڿ©->©ر
	stcGpioCfg.enOD = GpioOdDisable;
	///< GPIO IO ʼ     NSLEEP
	Gpio_Init(NEW_VALVE_NSLEEP_PORT, NEW_VALVE_NSLEEP_PIN, &stcGpioCfg);	
	Gpio_Init(NEW_VALVE_OPEN_PORT, NEW_VALVE_OPEN_PIN, &stcGpioCfg);	
	Gpio_Init(NEW_VALVE_CLOSE_PORT, NEW_VALVE_CLOSE_PIN, &stcGpioCfg);
	Gpio_Init(NEW_STA_PORT, NEW_STA_PIN, &stcGpioCfg);	
	

	/*ǶĿ*/	
	stcGpioCfg.enDir = GpioDirIn;	//
	Gpio_Init(NEW_VALVE_V_CHECK_PORT, NEW_VALVE_V_CHECK_PIN, &stcGpioCfg);	
	Gpio_Init(NEW_STA_CL_PORT, NEW_STA_CL_PIN, &stcGpioCfg);	
	Gpio_Init(NEW_STA_OP_PORT, NEW_STA_OP_PIN, &stcGpioCfg);	
	
	/*ʼio*/
	Gpio_WriteOutputIO(NEW_VALVE_NSLEEP_PORT, NEW_VALVE_NSLEEP_PIN, FALSE);	
	Gpio_WriteOutputIO(NEW_VALVE_OPEN_PORT, NEW_VALVE_OPEN_PIN, FALSE);
	Gpio_WriteOutputIO(NEW_VALVE_CLOSE_PORT, NEW_VALVE_CLOSE_PIN, FALSE);
	Gpio_WriteOutputIO(NEW_STA_PORT, NEW_STA_PIN, FALSE);
	
	if( (VALVE_STATE_OPEN != Sys_data_object.P1.ies_valve_paras.valve_state) && 
		(VALVE_STATE_OPEN_EMERGENCY != Sys_data_object.P1.ies_valve_paras.valve_state) && 
		(VALVE_STATE_CLOSE != Sys_data_object.P1.ies_valve_paras.valve_state)&& 
		(VALVE_STATE_CLOSE_EMERGENCY != Sys_data_object.P1.ies_valve_paras.valve_state) && 
		(VALVE_STATE_CLOSE_LOCK != Sys_data_object.P1.ies_valve_paras.valve_state))
	{
		Sys_data_object.P1.ies_valve_paras.valve_state = VALVE_STATE_OPEN;			//Ĭͨ
		Sys_data_object.P1.ies_valve_paras.valve_err = 0;
	}
	if(Sys_data_object.P1.ies_valve_paras.valve_total_time<7)
	{
		Sys_data_object.P1.ies_valve_paras.valve_total_time = 20;
	}
	if((Sys_data_object.P1.ies_valve_paras.valve_AD<VALVE_HOGH_ADC_VALUE_MIN)||
	   (Sys_data_object.P1.ies_valve_paras.valve_AD>VALVE_HOGH_ADC_VALUE_MAX))
	{
		Sys_data_object.P1.ies_valve_paras.valve_AD = VALVE_HOGH_ADC_VALUE;
	}
	valve_time_ms = Sys_data_object.P1.ies_valve_paras.valve_total_time * 200;			//طʱ
	valve_adc_voltage_thd = Sys_data_object.P1.ies_valve_paras.valve_AD *2;
	
  //طϱĸʽж
    if((Sys_data_object.P1.ies_valve_up_times.valve_up_times_pre > 36) || (Sys_data_object.P1.ies_valve_up_times.valve_up_times_pre < 1)  || (Sys_data_object.P1.ies_valve_up_times.valve_up_times_total > 250))
    {
        Sys_data_object.P1.ies_valve_up_times.valve_up_times_pre = 2;    //Ĭ2*30min
        Sys_data_object.P1.ies_valve_up_times.valve_up_times_total = 48;    //Ĭ48
    }
    if(Sys_data_object.P1.ies_valve_up_times.valve_up_times_realtime > (Sys_data_object.P1.ies_valve_up_times.valve_up_times_total + 1))
    {
        Sys_data_object.P1.ies_valve_up_times.valve_up_times_realtime = 0;
    }
    if((VALVE_AUTO_CHECK_OPEN != Sys_data_object.P1.ies_valve_up_times.valve_auto_check) && (VALVE_AUTO_CHECK_CLOSE != Sys_data_object.P1.ies_valve_up_times.valve_auto_check))
    {
        Sys_data_object.P1.ies_valve_up_times.valve_auto_check = VALVE_AUTO_CHECK_OPEN;
    }
	if(Sys_data_object.P1.ies_pulse_emergency.datas == 0 || Sys_data_object.P1.ies_pulse_emergency.datas > MAX_EMERGENCY_NUM)	//Ӧˮ
	{
		Sys_data_object.P1.ies_pulse_emergency.datas = 2;
	}   
}
/*************************************************************************************
 * @fun_name    :ValveIfIdle
 * @brief       :valve????idle??
 * @param[in] 	:NONE
 * @param[out] 	:None
 * @retval     	:
 * @other       :
 *************************************************************************************/
u8 ValveIfIdle(void)
{
    if (VALVE_IDLE == s_g_valve_s)
    {
        return (1);
    }
    else
    {
        return (0);
    }
}
/*************************************************************************************
 * @fun_name   valve_start_task
 * @brief       
 * @param[in] 	VALVE_TO_OPEN/ VALVE_TO_CLOSE/VALVE_HALF_OPEN
 * @param[out] 	:None
 * @retval     	:SUCCESS/ERROR
 * @other       :ڶʱµָ
 *************************************************************************************/
void ValveStartTask(u8 state)
{
    /*ȽвĺϷж*/
    if (VALVE_TO_OPEN != state && VALVE_TO_CLOSE != state && VALVE_TO_HALF_OPEN != state)
    {
        return;
    }
    else
    {
        s_g_valve_open_close = state; /*¼յĿطָ*/
		s_g_error_count = 0;
		g_valve_store_err_state_flag = 0;
		Sys_data_object.P1.ies_valve_paras.valve_err = 0;
		Gpio_WriteOutputIO(NEW_STA_PORT, NEW_STA_PIN,TRUE);
		Gpio_WriteOutputIO(NEW_VALVE_NSLEEP_PORT, NEW_VALVE_NSLEEP_PIN, TRUE);	
		ValveSetState();	//״̬idleΪidle
    }
}

void ValveSetState(void)
{
	s_g_valve_s = VALVE_S1;
}



/*************************************************************************************
 * @fun_name    : ValveGetState
 * @brief       :??????
 * @param[in] 	:NONE
 * @param[out] 	:None
 * @retval     	:s_g_valve_state 
 * @other       :
 *************************************************************************************/
u8 ValveGetState(void)
{
    return Sys_data_object.P1.ies_valve_paras.valve_state;
}

void ValveMachineDriver()
{
    ValveActMachineDriver();
    ValveAdcMachineDriver();
	ValveStoreEeDriver();
	ValveInitOperate();

}


/*************************************************************************************
 * @fun_name    :ValveActMachineDriver
 * @brief       :???????
 * @param[in] 	:NONE
 * @param[out] 	:NONE
 * @retval     	:None
 * @other       :
 *************************************************************************************/
void VALVE_V_STA(u8 sta)
{
	(sta==1)?Gpio_WriteOutputIO(NEW_STA_PORT, NEW_STA_PIN, TRUE):Gpio_WriteOutputIO(NEW_STA_PORT, NEW_STA_PIN, FALSE);
}

void VALVE_OPEN(u8 sta)
{
	(sta==1)?Gpio_WriteOutputIO(NEW_VALVE_OPEN_PORT, NEW_VALVE_OPEN_PIN, TRUE):Gpio_WriteOutputIO(NEW_VALVE_OPEN_PORT, NEW_VALVE_OPEN_PIN, FALSE);
}

void VALVE_CLOSE(u8 sta)
{
	(sta==1)?Gpio_WriteOutputIO(NEW_VALVE_CLOSE_PORT, NEW_VALVE_CLOSE_PIN, TRUE):Gpio_WriteOutputIO(NEW_VALVE_CLOSE_PORT, NEW_VALVE_CLOSE_PIN, FALSE);
}
void ValveClearAdcMessage(void) 
{
    valve_adc_check_msg = VALVE_NORMAL_POWER;
}

//ϵλʱԷŵķ
void ValveInitOperate()
{
    switch(s_g_valve_init_s)
    {
        case 0:
        {
            if(1 == g_valve_init_flag)
            {
                g_valve_init_flag = 2;
                Gpio_WriteOutputIO(NEW_STA_PORT, NEW_STA_PIN, TRUE); /*λ⹩*/
				__NOP();
                __NOP();
                __NOP();
                __NOP();
                __NOP();
                ValveGetInplaceOrder();
                if((VALVE_STATE_OPEN == Sys_data_object.P1.ies_valve_paras.valve_state) || (VALVE_STATE_OPEN_EMERGENCY == Sys_data_object.P1.ies_valve_paras.valve_state))
                {
                    if(VALVE_IN_PLACE != valve_if_op)   //δλ
                    {
                        Set5msTimer(TIMER_5MS_VALVE_INIT,200);
                        s_g_valve_init_s = 1;
                    }
                    else
                    {
                        Gpio_WriteOutputIO(NEW_STA_PORT, NEW_STA_PIN, FALSE);  /*λϵ*/
						Sys_data_object.P1.ies_valve_paras.valve_err = 0;
                    }
                }
                else if((VALVE_STATE_CLOSE == Sys_data_object.P1.ies_valve_paras.valve_state) || (VALVE_STATE_CLOSE_EMERGENCY == Sys_data_object.P1.ies_valve_paras.valve_state) || (VALVE_STATE_CLOSE_LOCK == Sys_data_object.P1.ies_valve_paras.valve_state))
                {
                    if(VALVE_IN_PLACE != valve_if_cl)   //δطλ
                    {
                        Set5msTimer(TIMER_5MS_VALVE_INIT,200);
                        s_g_valve_init_s = 2;
                    }
                    else
                    {
                        Gpio_WriteOutputIO(NEW_STA_PORT, NEW_STA_PIN, FALSE);  /*λϵ*/
						Sys_data_object.P1.ies_valve_paras.valve_err = 0;
                    }
                }
                else
                {
                    Gpio_WriteOutputIO(NEW_STA_PORT, NEW_STA_PIN, FALSE);  /*λϵ*/
                }
            }
        }
        break;
        
        case 1:
        {
            if(0 == Check5msTimer(TIMER_5MS_VALVE_INIT))
            {
                if(ValveIfIdle())
                {
                    ValveStartTask(VALVE_TO_OPEN);
                    s_g_valve_init_s = 0;
                }
            }
        }
        break;
        
        case 2:
        {
            if(0 == Check5msTimer(TIMER_5MS_VALVE_INIT))
            {
                if(ValveIfIdle())
                {
                    ValveStartTask(VALVE_TO_CLOSE);
                    s_g_valve_init_s = 0;
                }
            }
        }
        break;
    }
}

void ValveStoreEeDriver(void)
{
    switch(s_g_valve_store_s)
    {
        case 0:
        {
            if(0xAA == g_valve_store_rcv_state_flag)//״̬EE
            {
                s_g_valve_store_s = 1;
            }
			else if(0xAA == g_valve_store_err_state_flag)//쳣״̬EE
			{
				s_g_valve_store_s = 2;
			}
			else if(FrameCheckMsgApp(MsgChangcha_ValveUploadCnts))//طϱıEE
			{
				FrameClearMsgApp(MsgChangcha_ValveUploadCnts);
				s_g_valve_store_s = 3;
			}
			else if(FrameCheckMsgApp(MsgValve_EmergencyFlowStore))//ӦӦˮEE
			{
				FrameClearMsgApp(MsgValve_EmergencyFlowStore);
				s_g_valve_store_s = 4;
			}
        }
		break;

        case 1:
        {
            if(EepIfIdle())
            {
                g_valve_store_rcv_state_flag = 0;
                g_valve_message_temp = 0;
				EepWrite(&Sys_data_object.P1.ies_valve_paras.valve_state,ee_addr_compute((u8*)(&Sys_data_object.P1.ies_valve_paras.valve_state)),1,&g_valve_message_temp);
                s_g_valve_store_s = 10;
            }
        }
        break;
		
		case 2:
		{
			if(EepIfIdle())
            {
                g_valve_store_err_state_flag = 0;
                g_valve_message_temp = 0;
				EepWrite(&Sys_data_object.P1.ies_valve_paras.valve_err,ee_addr_compute((u8*)(&Sys_data_object.P1.ies_valve_paras.valve_err)),1,&g_valve_message_temp);
                s_g_valve_store_s = 10;
            }
		}
		break;
		
        case 3:
		{
			if(EepIfIdle())
            {
                g_valve_message_temp = 0;
				EepWrite(&Sys_data_object.P1.ies_valve_up_times.valve_up_times_realtime,ee_addr_compute((u8*)(&Sys_data_object.P1.ies_valve_up_times.valve_up_times_realtime)),1,&g_valve_message_temp);
                s_g_valve_store_s = 10;
            }
		}
		break;
		
		case 4:
		{
			if(EepIfIdle())
            {
                g_valve_message_temp = 0;
				EepWrite(&Sys_data_object.P1.ies_pulse_remain.data_buf[0],ee_addr_compute((u8*)(&Sys_data_object.P1.ies_pulse_remain.datas)),4,&g_valve_message_temp);
                s_g_valve_store_s = 10;
            }
		}
		break;
		
        case 10:
        {
			if(EepIfIdle())
			{
				s_g_valve_store_s = 0;   
			}    
        }
		break;
		
        default:
		{
            s_g_valve_store_s = 0;
		}
        break;
    }
}

void ValveActMachineDriver(void)
{
	switch (s_g_valve_s)
	{
		/**/
		case VALVE_IDLE:
		{
			;
		}
		break;
		
		case VALVE_S1:
		{
			if (VALVE_TO_OPEN == s_g_valve_open_close) 			//յָ
			{
				Set5msTimer(TIMER_5MS_VALVE_MAIN, valve_time_ms); 	//󿪷ʱ
                Set5msTimer(TIMER_5MS_VALVE, VALVE_CHECK_TIME); 	//ʱ
                ValvePowerOnOrder(OPEN_POWER_ON,CLOSE_POWER_OFF);			
                s_g_valve_s = VALVE_S2;
			}
			else if (VALVE_TO_CLOSE == s_g_valve_open_close)	//ط
			{
				Set5msTimer(TIMER_5MS_VALVE_MAIN, valve_time_ms);
                Set5msTimer(TIMER_5MS_VALVE, VALVE_CHECK_TIME); 	//ʱ
                ValvePowerOnOrder(OPEN_POWER_OFF,CLOSE_POWER_ON);
                s_g_valve_s = VALVE_S2;
			}
			else if (VALVE_TO_HALF_OPEN == s_g_valve_open_close) 	//뿪
			{
				ValveGetInplaceOrder();     						//жϵǰ
                if (VALVE_IN_PLACE == valve_if_cl)  				//طλ
                {
                    Set5msTimer(TIMER_5MS_VALVE_MAIN, 600); 		//3s
                    Set5msTimer(TIMER_5MS_VALVE, VALVE_CHECK_TIME); //ʱ
                    ValvePowerOnOrder(OPEN_POWER_ON,CLOSE_POWER_OFF);
                    s_g_valve_s = VALVE_S2;
                }
                else if(VALVE_IN_PLACE == valve_if_op)  			//λ
                {
                    Set5msTimer(TIMER_5MS_VALVE_MAIN, 500);			//2.5s
                    Set5msTimer(TIMER_5MS_VALVE, VALVE_CHECK_TIME); //ʱ
                    ValvePowerOnOrder(OPEN_POWER_OFF,CLOSE_POWER_ON);
                    s_g_valve_s = VALVE_S2;
                }
                else												//طŵλ߾δλʱ
                {
                    VALVE_V_STA(0);
                    s_g_valve_open_close = 0;
                    s_g_valve_s = VALVE_IDLE;
                }
			}
		}
		break;
		
		case VALVE_S2:
		{
			if(0 == Check5msTimer(TIMER_5MS_VALVE)) 						//ʱ
            {
                if (0 == Check5msTimer(TIMER_5MS_VALVE_MAIN)) 				//ʱ
                {
                    ValvePowerOnOrder(OPEN_POWER_ON,CLOSE_POWER_ON);    	//õ
					VALVE_V_STA(0);
                    s_g_valve_open_close = 0;
                    s_g_error_count = 0;
					if(VALVE_TO_HALF_OPEN != s_g_valve_open_close)			//ǰ뿪ָ
					{
						Sys_data_object.P1.ies_valve_paras.valve_err = 1;		//ʱ쳣
					}
                    s_g_valve_s = VALVE_S4;       
                }
                else
                {
					ValveGetInplaceOrder();     							//жϵǰ
					if(VALVE_IN_PLACE == valve_if_op) 						//λ
                    {
						if(VALVE_TO_OPEN == s_g_valve_open_close)
						{
							ValvePowerOnOrder(OPEN_POWER_ON,CLOSE_POWER_ON);	//õ
							VALVE_V_STA(0);
							s_g_error_count = 0;
							s_g_valve_open_close = 0;
							s_g_valve_s = VALVE_S4;
						}
                    }
					else if(VALVE_IN_PLACE == valve_if_cl)					//صλ
					{
						if(VALVE_TO_CLOSE == s_g_valve_open_close)
						{
							ValvePowerOnOrder(OPEN_POWER_ON,CLOSE_POWER_ON);	//õ
							VALVE_V_STA(0);
							s_g_error_count = 0;
							s_g_valve_open_close = 0;
							s_g_valve_s = VALVE_S4;
						}
					}
					else
					{
						if (valve_adc_check_msg == VALVE_HIGH_POWER) 					//ǹ
						{
							ValveClearAdcMessage();
							ValvePowerOnOrder(OPEN_POWER_ON,CLOSE_POWER_ON);    //õ
                            s_g_error_count++;
							if (s_g_error_count >= VALVE_ERROR_MAX)
                            {
								ValvePowerOnOrder(OPEN_POWER_ON,CLOSE_POWER_ON);	//õ
                                VALVE_V_STA(0);
                                s_g_valve_open_close = 0;
                                s_g_error_count = 0;			
								Sys_data_object.P1.ies_valve_paras.valve_err = 1;		//ת쳣
                                s_g_valve_s = VALVE_S4;
                            }
							else /*תСԤֵ*/
                            {
								Set5msTimer(TIMER_5MS_VALVE, VALVE_PAUSE_TIME);
								s_g_valve_s = VALVE_S3;
                            }
						}
					}
                }
            }
		}
		break;
		
		//ȴVALVE_S1
		case VALVE_S3:
		{
			if(0 == Check5msTimer(TIMER_5MS_VALVE))
            {
                s_g_valve_s = VALVE_S1;
            }
		}
		break;
		
		//ȴVALVE_IDLE
		case VALVE_S4:
		{
			//FrameSetMsgApp(MsgNbUploadByValveStateChange);
			g_valve_store_err_state_flag = 0xAA;		//ŶϣEEǷ쳣־
			s_g_valve_s = VALVE_IDLE;
		}
		break;
		
		default:
		{
			ValvePowerOnOrder(OPEN_POWER_ON,CLOSE_POWER_ON);    //õ
            VALVE_V_STA(0);
            s_g_valve_s = VALVE_IDLE;
		}
		break;
		
	}
}

/*************************************************************************************
 * @fun_name    :ValveAdcMachineDriver
 * @brief       :??????
 * @param[in] 	:NONE
 * @param[out] 	:NONE
 * @retval     	:1/0
 * @other       :
 *************************************************************************************/
void ValveAdcMachineDriver(void) 
{
	switch (s_g_adc_valve_s) 
	{
		case 0:
		{
			if (ValveIfIdle() == 0) 
			{
				valve_adc_check_msg = VALVE_NORMAL_POWER;
				valve_adc_count = 0;
				s_g_adc_valve_s = 1;
				Set5msTimer(TIMER_5MS_VALVE_ADC_CHECK, VALVE_CHECK_TIME);
			}
			break;
		}
		case 1:
		{
			if (0 == Check5msTimer(TIMER_5MS_VALVE_ADC_CHECK)) //?????????50ms????AD??
			{
				s_g_adc_valve_s = 2;
				Set5msTimer(TIMER_5MS_VALVE_ADC_CHECK, 10);
			}
			break;
		}
		case 2:
		{
			if (AdcIfIdle()) 
			{ //ADC idle??ADC??????????AD??,??50ms??ad????????        
				valve_adc_count++;
				AdcStartConvert(CHANNEL_VALVE_CHECK,4,0,&g_valve_adc_energy, &valve_adc_complete); //?????5???????????,??????
				Set5msTimer(TIMER_5MS_VALVE_ADC_CHECK, 10);
				s_g_adc_valve_s = 3;
			} 
			else if (0 == Check5msTimer(TIMER_5MS_VALVE_ADC_CHECK))//??ADC???idle        
			{
				s_g_adc_valve_s = 0;
			}
			break;
		}
		case 3:
		{
			if (TRUE == valve_adc_complete) /*????,???????*/
			{
				s_g_adc_valve_s = 4;
			} 
			else if (0 == Check5msTimer(TIMER_5MS_VALVE_ADC_CHECK))//??ad????????
			{
				s_g_adc_valve_s = 0;
			}
			break;
		}
		case 4:
		{
			if (valve_adc_voltage_thd > g_valve_adc_energy) 
			{
				valve_adc_check_msg = VALVE_NORMAL_POWER; //0913
				valve_adc_count = 0;
				s_g_adc_valve_s = 5;
			} 
			else 
			{
				s_g_adc_valve_s = 2;
				if (valve_adc_count > 3)//???????????,??????
				{
					valve_adc_count = 0;
					valve_adc_check_msg = VALVE_HIGH_POWER; //0913
					//                        Set5msTimer(TIMER_5MS_VALVE_ADC_CHECK, 2);
					s_g_adc_valve_s = 5;
				}
			}
			break;
		}

		case 5://
		{
			if (ValveIfIdle() == 0) 
			{
				Set5msTimer(TIMER_5MS_VALVE_ADC_CHECK, 2);
				s_g_adc_valve_s = 1;
			} 
			else 
			{
				Gpio_WriteOutputIO(NEW_VALVE_NSLEEP_PORT, NEW_VALVE_NSLEEP_PIN, FALSE);	
				s_g_adc_valve_s = 0;
			}
			break;
		}
		default:
		{
			Gpio_WriteOutputIO(NEW_VALVE_NSLEEP_PORT, NEW_VALVE_NSLEEP_PIN, FALSE);	
			s_g_adc_valve_s = 0;
			break;
		}
	}
}

/*************************************************************************************
 * @fun_name    :ValveIfSleep
 * @brief       :صԪǷ
 * @param[in] 	:NONE
 * @param[out] 	:NONE
 * @retval     	:1/0
 * @other       :
 *************************************************************************************/
u8 ValveIfSleep(void)
{
    if (VALVE_IDLE == s_g_valve_s && (0 == s_g_adc_valve_s) && (0 == s_g_valve_store_s) && (0 == s_g_valve_init_s))
    {
        return (1);
    }
    else
    {
        return (0);
    }
}

/*************************************************************************************
 * @fun_name    :ValvePreSleep
 * @brief       :صԪߴ
 * @param[in] 	?NONE
 * @param[out] 	:NONE
 * @retval     	:None
 * @other       :
 *************************************************************************************/
void ValvePreSleep(void)
{
	    /*nSleep*/
	stc_gpio_cfg_t stcGpioCfg;

	DDL_ZERO_STRUCT(stcGpioCfg);
	stcGpioCfg.enDir = GpioDirOut;
	///< ˿->
	stcGpioCfg.enDrv = GpioDrvL;
	///< ˿->
	stcGpioCfg.enPu = GpioPuDisable;
	stcGpioCfg.enPd = GpioPdDisable;
	///< ˿ڿ©->©ر
	stcGpioCfg.enOD = GpioOdDisable;
	///< GPIO IO ʼ     NSLEEP
	Gpio_Init(NEW_VALVE_NSLEEP_PORT, NEW_VALVE_NSLEEP_PIN, &stcGpioCfg);	
    Gpio_WriteOutputIO(NEW_VALVE_NSLEEP_PORT, NEW_VALVE_NSLEEP_PIN, FALSE);//NSLEEP㣬PT2466
	if(0 == g_valve_init_flag)
	{
		g_valve_init_flag = 1;
	}
}

/*************************************************************************************
 * @fun_name    :ValveWakeSleep
 * @brief       :ѷصԪ
 * @param[in] 	:NONE
 * @param[out] 	:NONE
 * @retval     	:None
 * @other       :
 *************************************************************************************/
void ValveWakeSleep(void)
{
    ;
}

//ȡӲʵ״̬
u8  ValveGetLineInSpace(void)
{
    u8 temp = 0;
	VALVE_V_STA(1);		//λ⹩
	__NOP();
	__NOP();
	__NOP();
	__NOP();
	__NOP();
	__NOP();
	__NOP();
	__NOP();
	__NOP();
	__NOP();
    ValveGetInplaceOrder();     //жϵǰ
    if((VALVE_IN_PLACE != valve_if_cl) && (VALVE_IN_PLACE == valve_if_op))		//λ
    {
        temp = 0x00;
    }
    else if((VALVE_IN_PLACE == valve_if_cl) && (VALVE_IN_PLACE != valve_if_op)) //طλ
    {
        temp = 0x10;
    }
    else 
    {
        temp = 0x30;
    }
    if(ValveIfIdle())
    {
        VALVE_V_STA(0);	
    }
    return temp;
}

void ValveUpdatePara(void)
{
//	valve_power_order = Sys_data_object.P1.ies_valve_paras.valve_power_order;	//
//	valve_inplace_order = Sys_data_object.P1.ies_valve_paras.valve_inplace_order;//λ
	valve_time_ms = Sys_data_object.P1.ies_valve_paras.valve_total_time * 200;			//طʱ
	valve_adc_voltage_thd = (Sys_data_object.P1.ies_valve_paras.valve_AD << 8) * 5 / 1000;		//ADֵ
}

void ValvePowerOnOrder(u8 IsOpen,u8 IsClose)
{
//    switch(valve_power_order)
//    {
//        case 0xBB:
//        {
			VALVE_OPEN(IsOpen);
			VALVE_CLOSE(IsClose);
//            break;
//        }
//        case 0xAA:
//        {
//            VALVE_OPEN(IsClose);
//			VALVE_CLOSE(IsOpen);
//            break;
//        }
//        default:
//        {
//            VALVE_OPEN(IsClose);
//			VALVE_CLOSE(IsOpen);
//            break;
//        }
//    }
}

void ValveGetInplaceOrder(void)
{
//    switch(valve_inplace_order) //жϵǰ
//    {
//        case 0xBB:
//        {
			valve_if_op = Gpio_GetInputIO(NEW_STA_OP_PORT, NEW_STA_OP_PIN);
            valve_if_cl = Gpio_GetInputIO(NEW_STA_CL_PORT, NEW_STA_CL_PIN);
//            break;
//        }
//        case 0xAA:
//        {
//			valve_if_op = Gpio_GetInputIO(NEW_STA_CL_PORT, NEW_STA_CL_PIN);
//            valve_if_cl = Gpio_GetInputIO(NEW_STA_OP_PORT, NEW_STA_OP_PIN);
//            break;
//        }
//        default:
//        {
//			valve_if_op = Gpio_GetInputIO(NEW_STA_CL_PORT, NEW_STA_CL_PIN);
//            valve_if_cl = Gpio_GetInputIO(NEW_STA_OP_PORT, NEW_STA_OP_PIN);
//            break;
//        }
//    }
}

void ValveStoreRcvState(u8 state)
{
    if((VALVE_STATE_CLOSE == state) || (VALVE_STATE_CLOSE_EMERGENCY == state) || (VALVE_STATE_CLOSE_LOCK == state) || (VALVE_STATE_OPEN_EMERGENCY == state) || (VALVE_STATE_OPEN == state))
    {
        g_valve_store_rcv_state_flag =0xAA;
		Sys_data_object.P1.ies_valve_paras.valve_state = state;
    }
}
#endif

#ifdef __cplusplus
}
#endif

/***************************************************************END OF FILE****/

